// $Rev: 48 $
// $Author: omgitsjustjava $
// $Date: 2016-04-17 17:00:48 +0200 (So, 17. Apr 2016) $

/**
 * Initialisiert das PhotoSwipe-Plugin.
 */
function initPhotoSwipePlugin() {
	$('.picture').each(function() {
		var $pic = $(this);
		// Funktion, die die Bilder zusammensammelt
		var getItems = function() {
			var items = [];
			$pic.find('figure').children('a').each(function() {
				var $href = $(this).attr('href'), $size = $(this).attr('data-size').split('x'), $width = $size[0], $height = $size[1];
				$title = $(this).attr('title');
				var item = {
					src : $href,
					w : $width,
					h : $height,
					title : $title
				}
				items.push(item);
			});
			return items;
		}
		var items = getItems();

		// Bild mit gerade angeklicktem Index öffnen
		var $pswp = $('.pswp')[0];
		$pic.unbind('click').on('click', 'figure', function(event) {
			event.preventDefault();
			var index = parseInt($(this).attr('data-index'));
			var options = {
				// siehe http://photoswipe.com/documentation/options.html
				index : index,
				bgOpacity : .9,
				loop : false,
				closeOnScroll : false,
				closeOnVerticalDrag : false,
				// anzuzeigende Elemente
				closeEl : true,
				captionEl : true,
				fullscreenEl : true,
				zoomEl : true,
				shareEl : false,
				counterEl : true,
				arrowEl : true,
				preloaderEl : true
			}

			// Autoplay-Button hinzufügen
			var autoplayIntervall = 5000; // ein Bild alle x Sekunden
			if ($('.pswp__button--autoplay').length === 0) {
				$('<button class="pswp__button pswp__button--autoplay" title="Automatisch abspielen"></button>').insertAfter('.pswp__button--zoom');
			}

			var _autoplayId = null;
			$('.pswp__button--autoplay').on('click', function(event) {
				event.preventDefault();
				if (_autoplayId) {
					clearInterval(_autoplayId);
					_autoplayId = null;
					$('.pswp__button--autoplay').removeClass('stop').attr('title','Automatisch abspielen');
				} else {
					_autoplayId = setInterval(function() {
						lightBox.next();
					}, autoplayIntervall);
					$('.pswp__button--autoplay').removeClass('stop').attr('title','Abspielen beenden');
					$('.pswp__button--autoplay').addClass('stop');
				}
			});

			// LOS! :)
			var lightBox = new PhotoSwipe($pswp, PhotoSwipeUI_Default, items, options);
			lightBox.init();
		}); // $pic.on('click' ...

	}); // $('.picture').each( ...

} // function initPhotoSwipePlugin()